clc;
clear;

alpha = 0.05;

C = 1000;
T_set = [50,100,200,50,100,200]';
n_set = [100,100,100,150,150,150]';
r = 2;
h = 4;
J = 10;
k1 = 0.7500;
k2 = 0.5393;

phi_set = [0]';
% phi_set = [0.3, 0.5, 0.7]';

a = [1, 1, 1]';

cnt = zeros(C,1);
cnt_MSE = zeros(C,1);

p = 2 ;                           %% Parzen exponential characteristic
K_p = -6 ;                        %% Exponential characteristic of Parzen Kernel            


for cc = 1 : size(T_set,1);

    T = T_set(cc,1);
    n = n_set(cc,1);
    
    dn = [ceil(n/2):n]'; 

    cor = zeros(n,1);

    rho = [0.3, 0.3^2]';

    D1 = repmat([1:n]',1,n);
    D2 = repmat([1:n],n,1);
    D = abs(D1-D2);

    dn_star = zeros(C,1);

    W_temp = (D<=1) - eye(n,n)  ;
    s = repmat(sum(W_temp,2),1,n);
    W = W_temp./s;                                  %% standardized Spatial Weight Matrix (True)

    ln = zeros(size(dn,1),1);                                %% average number of individual withdin bandwidth

    for s = 1:size(dn,1) ;
        for ss = 1:n;
            ln_temp(ss,1) = sum(D(:,ss)<=dn(s,1))-1;
        end;
        ln(s,1) = mean(ln_temp);
    end;


    for c0 = 1 : size(phi_set,1);
%         phi = 0;
        phi = phi_set(c0);

        for j = 1 : J;
            cor(j,1) = phi^(j-1);
        end;

        Omega2 = toeplitz(cor);
        Omega = chol(Omega2);

        for c = 1 : C;

            sig_v_t = rand(1,n)+0.5;
            sig_v = repmat(sig_v_t,T,1);
            sig_u_t = rand(1,r)+0.5;
            sig_u = repmat(sig_u_t,T,1);
            
            u = sqrt(sig_u).*randn(T,r);

            f_temp = zeros(T+1,r);
            for t = 1 : T
                f_temp(t+1,:) = rho'.*f_temp(t,:) + sqrt(1-rho'.^2).*u(t,:);
            end;
            f = f_temp(2:end,:);
            lambda = rand(n,r);

            v = sqrt(sig_v).*randn(T,n);
            e = v*Omega;

            X = f*lambda' + e; 

            error = randn(T,1);
            yh_cm =  [ones(T,1) f]*a; 
            yh = yh_cm + error; 

            %% Estimation and prediction

            [evec_all_temp,eval_all_temp] = eig(X*X'/(T*n));
            [eval_all,ind] = sort(diag(eval_all_temp),'descend');

            evec_all = evec_all_temp(:,ind');
            f_til_temp = evec_all(:,1:r);
            diag_f_til_temp = diag(f_til_temp'*f_til_temp/T);
            f_til = f_til_temp./sqrt(repmat(diag_f_til_temp',T,1));
            lam_til = X'*f_til/T;
            V_til = diag(eval_all(1:r,1));

            z_hat = [ones(T,1), f_til];
            b_hat = z_hat(1:T-h,:)\yh(1:T-h);
            a_hat = b_hat(2:end,1);
            yh_cm_hat = z_hat*b_hat;

            eps_hat = yh(1:T-h) - yh_cm_hat(1:T-h); 

            e_til = X - f_til*lam_til';
            eT_til = e_til(end,:)';
            eta_T = lam_til.*repmat(eT_til,1,r);
            eta_T1 = eta_T(:,1);
            eta_T2 = eta_T(:,2);

            %% Heteroskedasticity robust variance estimator based PIs
            gamma_con = eta_T'*eta_T/n;

            AV_f_con = (V_til\gamma_con)/V_til;    
            B2_con = a_hat'*AV_f_con*a_hat;

             %% MSE based dn selection
            rho_hat1 = fminbnd(@(rho_hat1) myfun(rho_hat1, W, eta_T1), -1,1) ; 
            rho_hat2 = fminbnd(@(rho_hat2) myfun(rho_hat2, W, eta_T2), -1,1) ; 

            R_hat1 =   eye(n,n)/( eye(n,n) - rho_hat1*W)  ;
            R_hat2 =   eye(n,n)/( eye(n,n) - rho_hat2*W)  ;
            sigma_hat11 = (eta_T1-rho_hat1*W*eta_T1)'*(eta_T1-rho_hat1*W*eta_T1)/n*(R_hat1*R_hat1') ;    
            sigma_hat12 = (eta_T1-rho_hat1*W*eta_T1)'*(eta_T2-rho_hat2*W*eta_T2)/n*(R_hat1*R_hat2') ;    
            sigma_hat22 = (eta_T2-rho_hat2*W*eta_T2)'*(eta_T2-rho_hat2*W*eta_T2)/n*(R_hat2*R_hat2') ;    
            g_p_hat11 = ones(n,1)'*(sigma_hat11.*(D.^2))*ones(n,1) / n ;
            g_p_hat12 = ones(n,1)'*(sigma_hat12.*(D.^2))*ones(n,1) / n ;
            g_p_hat22 = ones(n,1)'*(sigma_hat22.*(D.^2))*ones(n,1) / n ;    
            g_p_hat = [g_p_hat11, g_p_hat12
                g_p_hat12, g_p_hat22];

            K_p2_g_p_hat2 = K_p^2*(a_hat'*((V_til\g_p_hat)/V_til)*a_hat)^2;

            g_hat11 = ones(n,1)'*sigma_hat11*ones(n,1) / n ;                          %% This is also parametric estimator of beta_hat
            g_hat12 = ones(n,1)'*sigma_hat12*ones(n,1) / n ;                          %% This is also parametric estimator of beta_hat
            g_hat22 = ones(n,1)'*sigma_hat22*ones(n,1) / n ;                          %% This is also parametric estimator of beta_hat
            g_hat = [g_hat11, g_hat12
                g_hat12, g_hat22];
            trace_kron_g_hat2 = (a_hat'*((V_til\g_hat)/V_til)*a_hat)^2;

            amse_hat = zeros(size(dn,1),1);

            for i = 1:size(dn,1);

                D_n = D/dn(i,1) ;
                K_bar = sum(sum((1-6*D_n.^2 + 6*abs(D_n).^3).*(abs(D_n) <= 0.5) + 2*(1-abs(D_n)).^3 .*(abs(D_n) > 0.5).*(abs(D_n) <= 1)))/(n*ln(i,1));

                amse_hat(i,1) = K_p2_g_p_hat2/dn(i,1)^(2*p) + 2*K_bar*ln(i,1)/n*trace_kron_g_hat2;

            end;

            x1 = find(amse_hat(:,1)==min(amse_hat(:,1)));
            dn_star(c,1) = dn(min(x1),1) ;
            D_star = D/dn_star(c,1) ;

            k = (1-6*D_star.^2 + 6*abs(D_star).^3).*(abs(D_star) <= 0.5) + 2*(1-abs(D_star)).^3 .*(abs(D_star) > 0.5).*(abs(D_star) <= 1);

            gamma_hat11 = sum(sum((eta_T1*eta_T1').*k))/n;
            gamma_hat12 = sum(sum((eta_T1*eta_T2').*k))/n;
            gamma_hat22 = sum(sum((eta_T2*eta_T2').*k))/n;

            gamma_hat = [gamma_hat11, gamma_hat12
                gamma_hat12, gamma_hat22];

            AV_f = (V_til\gamma_hat)/V_til;    
            B2 = a_hat'*AV_f*a_hat;
            
            Test_S = B2/B2_con; 

    %         Critical value
            cv_MSE = myfun_cv(k,n,alpha);

            cnt_MSE(c) = (Test_S > cv_MSE);
            
     
        end;

        phi
        C
        T
        n
        
        emp_cvg_MSE = sum(cnt_MSE)/C

    end;
end;

